// HaltWindow.cpp
// Copyright (C) 2018 Katayama Hirofumi MZ <katayama.hirofumi.mz@gmail.com>
// This file is public domain software.
#include <windows.h>
#include <windowsx.h>
#include <stdio.h>

#define TIMER_ID 999

BOOL OnInitDialog(HWND hwnd, HWND hwndFocus, LPARAM lParam)
{
    TCHAR szText[128];
    wsprintf(szText, TEXT("This window HWND is 0x%p"), hwnd);
    SetDlgItemText(hwnd, stc1, szText);

    SetDlgItemInt(hwnd, edt1, 5, FALSE);

    SetTimer(hwnd, TIMER_ID, 500, NULL);
    return TRUE;
}

void ShowMessageTime(void)
{
    static DWORD dwPrev = 0;
    printf("GetMessageTime(): 0x%08lX (diff: %ld)\n", GetMessageTime(), GetMessageTime() - dwPrev);
    dwPrev = GetMessageTime();
}

void OnOK(HWND hwnd)
{
    BOOL bTranslated;
    UINT nSeconds = GetDlgItemInt(hwnd, edt1, &bTranslated, FALSE);

    KillTimer(hwnd, TIMER_ID);

    for (int i = 0; i < nSeconds * 1000; i += 500)
    {
        ShowMessageTime();
        Sleep(500);
    }

    SetTimer(hwnd, TIMER_ID, 500, NULL);
}

void OnCommand(HWND hwnd, int id, HWND hwndCtl, UINT codeNotify)
{
    switch (id)
    {
    case IDOK:
        OnOK(hwnd);
        break;
    case IDCANCEL:
        EndDialog(hwnd, id);
        break;
    }
}

void OnTimer(HWND hwnd, UINT id)
{
    ShowMessageTime();
}

INT_PTR CALLBACK
DialogProc(HWND hwnd, UINT uMsg, WPARAM wParam, LPARAM lParam)
{
    switch (uMsg)
    {
        HANDLE_MSG(hwnd, WM_INITDIALOG, OnInitDialog);
        HANDLE_MSG(hwnd, WM_COMMAND, OnCommand);
        HANDLE_MSG(hwnd, WM_TIMER, OnTimer);
    }
    return 0;
}

int main(void)
{
    DialogBox(GetModuleHandle(NULL), MAKEINTRESOURCE(1), NULL, DialogProc);
    return 0;
}
